"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/content/Icon"));
var form_1 = require("@steroidsjs/core/ui/form");
var content_1 = require("@steroidsjs/core/ui/content");
require("./DropDownItemView.scss");
var GROUP_CONTENT_TYPE = 'group';
function DropDownItemView(props) {
    var bem = (0, useBem_1["default"])('DropDownItemView');
    var groupProps = props;
    var commonProps = {
        className: bem.element('option', {
            hover: props.hoveredId === props.item[props.primaryKey],
            select: props.selectedIds.includes(props.item[props.primaryKey]),
            size: props.size
        }),
        onFocus: function () { return props.onItemHover(props.item[props.primaryKey]); },
        onMouseOver: function () { return props.onItemHover(props.item[props.primaryKey]); },
        onClick: function (e) {
            e.preventDefault();
            props.onItemSelect(props.item[props.primaryKey]);
        }
    };
    var renderTypeCases = function (type, src) {
        switch (type) {
            case 'icon':
                return (react_1["default"].createElement("div", __assign({}, commonProps),
                    typeof src === 'string' ? (react_1["default"].createElement(Icon_1["default"], { name: src, className: bem.element('icon') })) : (react_1["default"].createElement("span", { className: bem.element('icon') }, src)),
                    react_1["default"].createElement("span", null, props.item.label)));
            case 'checkbox':
                return (react_1["default"].createElement("div", __assign({}, commonProps),
                    react_1["default"].createElement(form_1.CheckboxField, { label: props.item.label, className: bem.element('checkbox'), size: props.size, inputProps: {
                            checked: props.selectedIds.includes(props.item[props.primaryKey])
                        } })));
            case 'img':
                return (react_1["default"].createElement("div", __assign({}, commonProps),
                    react_1["default"].createElement("span", { className: bem.element('img') },
                        react_1["default"].createElement("img", { src: src, alt: "custom source for item" })),
                    react_1["default"].createElement("span", null, props.item.label)));
            case 'radio':
                return (react_1["default"].createElement("div", __assign({}, commonProps),
                    react_1["default"].createElement(form_1.RadioListField, { items: [props.item], selectedIds: props.selectedIds, className: bem.element('radio', {
                            size: props.size
                        }), size: props.size })));
            case 'group':
                return (react_1["default"].createElement(content_1.AccordionItem, { childIndex: groupProps.childIndex, isShowMore: groupProps.isShowMore, toggleAccordion: groupProps.toggleAccordion, toggleCollapse: groupProps.toggleCollapse, title: props.item.label, position: "middle", className: bem.element('group', {
                        size: props.size
                    }) }, props.item[props.groupAttribute].map(function (subItem, itemIndex) { return (react_1["default"].createElement(DropDownItemView, __assign({}, props, { key: itemIndex, item: subItem }))); })));
            default:
                return null;
        }
    };
    if (props.groupAttribute && Array.isArray(props.item[props.groupAttribute])) {
        return renderTypeCases(GROUP_CONTENT_TYPE, props.item[props.groupAttribute]);
    }
    if (props.item.contentType) {
        return renderTypeCases(props.item.contentType, props.item.contentSrc);
    }
    if (props.itemsContent) {
        return renderTypeCases(props.itemsContent.type, props.itemsContent.src);
    }
    return (react_1["default"].createElement("div", __assign({}, commonProps), props.item.label));
}
exports["default"] = DropDownItemView;
